# coding: utf-8

"""
    Magneto API

    Magneto API is the RESTful API for the Rely.io platform.

    The version of the OpenAPI document: v0.0.1
    Contact: contact@rely.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from magneto_api_client.models.plugin_legacy_file_to_check import PluginLegacyFileToCheck
from typing import Optional, Set
from typing_extensions import Self

class PluginLegacyFilesToCheckUpdate(BaseModel):
    """
    PluginLegacyFilesToCheckUpdate
    """ # noqa: E501
    files_to_check: Optional[List[PluginLegacyFileToCheck]] = Field(default=None, alias="filesToCheck")
    __properties: ClassVar[List[str]] = ["filesToCheck"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PluginLegacyFilesToCheckUpdate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in files_to_check (list)
        _items = []
        if self.files_to_check:
            for _item_files_to_check in self.files_to_check:
                if _item_files_to_check:
                    _items.append(_item_files_to_check.to_dict())
            _dict['filesToCheck'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PluginLegacyFilesToCheckUpdate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "filesToCheck": [PluginLegacyFileToCheck.from_dict(_item) for _item in obj["filesToCheck"]] if obj.get("filesToCheck") is not None else None
        })
        return _obj


